2. 
git clone git@gitlab.com:cong.nguyen7/gitpractice.git
 git checkout -b setup_trunk
   git add .
   git commit -m "fetch: add foder trunk-main"
   git push -u origin setup_trunk
 3.
 4. Rebase
 git clone git@gitlab.com:cong.nguyen7/gitpractice.git
git checkout -b feature_a
git rebase origin/setup_trunk  
5. Revert
git reset --hard
6. [Modify]

git add .
git commit -m "feat: add text to the end of the file applyPatches.bat"
git push -u origin feature_a

7. [Ignore]
git reset
git add .
git commit -m "feat: create file gitignore"
git push origin setup_trunk

8. [Submodule]
cd submodule
git submodule add https://gitlab.com/gitlab-examples/docker
git submodule add https://gitlab.com/gitlab-examples/ssh-private-key

9. [Create Tag]
git tag -a 0.0.1 -m "setup trunk"

10. [Merge request]
create merge request ---> setup_trunk ---> compare branches and continute --->assignee,reviewer
create labels Setup trunk
-->create merge request
merge	
11.[Accept merge request]
--> merge		
12.[Resolve conflict 1] giai quyet xung dot
 git clone git@gitlab.com:cong.nguyen7/gitpractice.git
 git status
 git add . 
 git commit -m "edit file applyPatshes.bat"
 git branch -a
 git merge origin/feature_a
 	Thong bao loi can sua vao file applyPatshes.bat sua lai
Auto-merging trunk-main/applyPatches.bat
CONFLICT (content): Merge conflict in trunk-mai	n/applyPatches.bat
Automatic merge failed; fix conflicts and then commit the result.
Sua loi
git status
git add .
git commit -m "Resolve conflict 1"
git push origin feature_b

13.[Update]
git add .
git commit -m "Modify file another_data.txt"
git push origin feature_b

14.[Merge to master]
git checkout main
git merge feature_b
git commit -m "Merge feature/b branch into master branch"
git push origin main

15.[Move]
git checkout main 
git pull 
git checkout feature_a
git merge main
git branch : *feature_a
mv data/csv/* data/text/* data/file
rm -r data/csv
rm -r data/text
git add .
git commit -m "Move all of file from ./data/csv and ./data/text to /data/file, delete ./data/csv
and ./data/text folder"
git push origin feature_a 
16.[Create Patch]
git rebase feature_a main
git diff > my_patch_file.patch
17.
git am --signoff < my_patch_file.patch
git add .
git commit -m "Add file patch form Workerr2"
18.[Revert specific commit]
git reset --hard HEAD^ :quay lại cam kết trước HEAD











